<?php
// admin/diagnose.php    Norbert Haider, University of Vienna, 2021
// part of MolDB6     last change: 2021-03-07

/**
 * @dir admin
 * @author Norbert Haider
 *
 * Script providing a diagnostic page
 */
/**
 * @file admin/diagnose.php
 * @author Norbert Haider
 * 
 * Script checks some relevant settings in the present MolDB6 installation.
 * 
 * 
 */

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head>
<style type="text/css">
body {background-color: #fff; color: #222; font-family: sans-serif;}
pre {margin: 0; font-family: monospace;}
a:link {color: #009; text-decoration: none; background-color: #fff;}
a:hover {text-decoration: underline;}
table {border-collapse: collapse; border: 0; width: 934px; box-shadow: 1px 2px 3px #ccc;}
.center {text-align: center;}
.center table {margin: 1em auto; text-align: left;}
.center th {text-align: center !important;}
td, th {border: 1px solid #666; font-size: 75%; vertical-align: baseline; padding: 4px 5px;}
h1 {font-size: 150%;}
h2 {font-size: 125%;}
.p {text-align: left;}
.e {background-color: #ccf; width: 300px; font-weight: bold;}
.h {background-color: #99c; font-weight: bold;}
.v {background-color: #ddd; max-width: 300px; overflow-x: auto; word-wrap: break-word;}
.v i {color: #999;}
.y {color: #000000; background-color: #00ff00; max-width: 300px; overflow-x: auto; word-wrap: break-word;}
.z {color: #ffffff; background-color: #ff0000; max-width: 300px; overflow-x: auto; word-wrap: break-word;}
img {float: right; border: 0;}
hr {width: 934px; background-color: #ccc; border: 0; height: 1px;}
</style>


<?php

$myname  = $_SERVER['PHP_SELF'];
$docroot = $_SERVER['DOCUMENT_ROOT'];

if (!defined('PHP_VERSION_ID')) {
    $version = explode('.', PHP_VERSION);
    define('PHP_VERSION_ID', ($version[0] * 10000 + $version[1] * 100 + $version[2]));
}
if (PHP_VERSION_ID < 50207) {
    define('PHP_MAJOR_VERSION',   $version[0]);
    define('PHP_MINOR_VERSION',   $version[1]);
    define('PHP_RELEASE_VERSION', $version[2]);
}

$dbmod_name = "mysql";
if ( PHP_MAJOR_VERSION > 5 ) { $dbmod_name = "mysqli"; }

$mod_arr = get_loaded_extensions();
$dbmod_status = 0;  // 0 = not installed, 1 = mysql installed, 2 = mysqli inmstalled
$sockmod_status = 0;
foreach ($mod_arr as $testmod) {
  if ($testmod == "sockets") { $sockmod_status = 1; }
  if ($testmod == $dbmod_name) {
    if ($dbmod_name == "mysql")  { $dbmod_status = 1; }
    if ($dbmod_name == "mysqli") { $dbmod_status = 2; }
  }
}


$cfg1_status = 0;  // 0 = not found, 1 = found in current dir, 2 = found in upper-level dir, 3 = found in include_path
$cfg1_name = "moldb6conf.php";
if ((@include "./" . $cfg1_name) != FALSE) { $cfg1_status = 1; } else {
  if ((@include "../" . $cfg1_name) != FALSE) { $cfg1_status = 2; } else {
    if ((@include $cfg1_name) != FALSE) { $cfg1_status = 3; }
  }
}

$cfg2_status = 0;  // 0 = not found, 1 = found in current dir, 2 = found in upper-level dir, 3 = found in include_path
$cfg2_name = "moldb6uiconf.php";
if ((@include "./" . $cfg2_name) != FALSE) { $cfg2_status = 1; } else {
  if ((@include "../" . $cfg2_name) != FALSE) { $cfg2_status = 2; } else {
    if ((@include $cfg2_name) != FALSE) { $cfg2_status = 3; }
  }
}

$mysql_charset = $charset;

echo "<body><div class='center'>\n";
echo "<h1>General information for this installation of MolDB6</h1>\n";

echo "<table>\n";
echo "<tr><td class='e'>Current PHP version </td>" . "<td class='v'>" . phpversion() . " </td></tr>\n";
echo "<tr><td class='e'>PHP/MySQL module ($dbmod_name)</td>";
if ($dbmod_status > 0) {echo "<td class='y'>installed</td></tr>\n"; } else { echo "<td class='z'>not installed</td></tr>\n";  }
echo "<tr><td class='e'>PHP sockets module (optionl, for cmmm server)</td>";
if ($sockmod_status > 0) {
  echo "<td class='y'>installed</td></tr>\n"; 
} else { 
  $r_col = "v";
  if ($use_cmmmsrv == "y") { $r_col = "z"; }
  echo "<td class='" . $r_col . "'>not installed</td></tr>\n";  
}
echo "<tr><td class='e'>Configuration file 1 ($cfg1_name)</td>";
if ($cfg1_status > 0) {
 if ($cfg1_status == 1) { echo "<td class='y'>found in current directory</td></tr>\n"; }
 if ($cfg1_status == 2) { echo "<td class='y'>found in upper-level directory</td></tr>\n"; } 
} else { echo "<td class='z'>not found</td></tr>\n"; }
echo "<tr><td class='e'>Configuration file 2 ($cfg2_name)</td>";
if ($cfg2_status > 0) {
 if ($cfg2_status == 1) { echo "<td class='y'>found in current directory</td></tr>\n"; }
 if ($cfg2_status == 2) { echo "<td class='y'>found in upper-level directory</td></tr>\n"; } 
} else { echo "<td class='z'>not found</td></tr>\n"; }

echo "<tr><td class='e'>this script (URL path) </td>" . "<td class='v'>" . $myname . " </td></tr>\n";
echo "<tr><td class='e'>web server document root </td>" . "<td class='v'>" . $docroot . " </td></tr>\n";

echo "</table>\n";

if ($cfg1_status > 0) {
  echo "<h1>Settings in $cfg1_name</h1>\n";
  echo "<table>\n";
  echo "<tr><td class='e'>database name </td>" . "<td class='v'>" . $database . " </td></tr>\n";
  echo "<tr><td class='e'>hostname </td>" . "<td class='v'>" . $hostname . " </td></tr>\n";
  echo "<tr><td class='e'>rw_user </td>" . "<td class='v'>" . $rw_user . " </td></tr>\n";
  echo "<tr><td class='e'>ro_user </td>" . "<td class='v'>" . $ro_user . " </td></tr>\n";
  echo "<tr><td class='e'>charset </td>" . "<td class='v'>" . $charset . " </td></tr>\n";
  echo "<tr><td class='e'>CHECKMOL executable </td>" . "<td class='v'>" . $CHECKMOL . " </td></tr>\n";
  $cmres = `$CHECKMOL`;
  $cm_arr = explode("\n",$cmres);
  $cmv = $cm_arr[0];
  $r_col = "z";
  if ((strpos($cmv,"checkmol") !== FALSE) && (strpos($cmv,"Vienna") !== FALSE)) { $r_col = "y"; }
  echo "<tr><td class='e'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;functionality check for CHECKMOL</td><td class='" . $r_col . "'>$cmv</td></tr>\n";
  echo "<tr><td class='e'>MATCHMOL executable </td>" . "<td class='v'>" . $MATCHMOL . " </td></tr>\n";  
  $mmres = `$MATCHMOL`;
  $mm_arr = explode("\n",$mmres);
  $mmv = $mm_arr[0];
  $r_col = "z";
  if ((strpos($mmv,"matchmol") !== FALSE) && (strpos($mmv,"Vienna") !== FALSE)) { $r_col = "y"; }
  echo "<tr><td class='e'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;functionality check for MATCHMOL</td><td class='" . $r_col . "'>$mmv</td></tr>\n";

  echo "<tr><td class='e'>MOL2SVG executable </td>" . "<td class='v'>" . $MOL2SVG . " </td></tr>\n";
  $m2sres = `$MOL2SVG`;
  $m2s_arr = explode("\n",$m2sres);
  $m2sv = $m2s_arr[1];
  $r_col = "z";
  if ((strpos($m2sv,"mol2svg") !== FALSE) && (strpos($m2sv,"Haider") !== FALSE)) { $r_col = "y"; }
  echo "<tr><td class='e'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;functionality check for MOL2SVG</td><td class='" . $r_col . "'>$m2sv</td></tr>\n";

  if (strlen($bitmapdir) == 0) {
    $bmstr = "(disabled)";
    $r_col = "v";
  } else {
    if (file_exists($bitmapdir)) {
      $bmstr = $bitmapdir . " &nbsp;&nbsp;&nbsp;&nbsp;(exists)";
      $r_col = "y";
    } else {
      $bmstr = $bitmapdir . " &nbsp;&nbsp;&nbsp;&nbsp;(does not exist)";
      $r_col = "z";
    }
  }
  echo "<tr><td class='e'>bitmap directory (optional)</td>" . "<td class='" . $r_col . "'>" . $bmstr . " </td></tr>\n";

  if (strlen($bitmapdir) > 0) {
    echo "<tr><td class='e'>MOL2PS executable </td>" . "<td class='v'>" . $MOL2PS . " </td></tr>\n";
    $m2pres = `$MOL2PS`;
    $m2p_arr = explode("\n",$m2pres);
    $m2pv = $m2p_arr[1];
    $r_col = "z";
    if ((strpos($m2pv,"mol2ps") !== FALSE) && (strpos($m2pv,"Haider") !== FALSE)) { $r_col = "y"; }
    echo "<tr><td class='e'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;functionality check for MOL2PS</td><td class='" . $r_col . "'>$m2pv</td></tr>\n";
    $gsres = `$GHOSTSCRIPT`;
    $gs_arr = explode("\n",$gsres);
    $gsv = $gs_arr[0];
    if (strlen($gsv) == 0) { $r_col = "z"; } else { $r_col = "y"; }
    echo "<tr><td class='e'>GHOSTSCRIPT executable </td>" . "<td class='v'>" . $GHOSTSCRIPT . " </td></tr>\n";
    echo "<tr><td class='e'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;functionality check for GHOSTSCRIPT</td><td class='" . $r_col . "'>$gsv</td></tr>\n";
  }   // if bitmapdir != ""

  if ((strlen($enable_inchi) > 0) && ( $enable_inchi == "y")) {
    echo "<tr><td class='e'>INCHI executable (optional)</td>" . "<td class='v'>" . $INCHI . " </td></tr>\n";
    $ires = `$INCHI`;
    $i_arr = explode("\n",$ires);
    $iv = $i_arr[0];
    if (strlen($iv) == 0) { $r_col = "z"; } else { $r_col = "y"; }
    echo "<tr><td class='e'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;functionality check for INCHI</td><td class='" . $r_col . "'>$iv</td></tr>\n";  
  }  // if enable_inchi 

  echo "</table>\n";
}


$currdir = getcwd();
$thisdir = basename($currdir);
if (($thisdir == "admin") || ($cfg2_status == 2)) {
  chdir("..");
  $cwd = getcwd();
  //echo "now in $cwd<br>\n";
}


if ($cfg2_status > 0) {
  echo "<h1>Settings in $cfg2_name</h1>\n";
  echo "<table>\n";
  $r_col = "v";
  $r_comment = "";
  if ($use_cmmmsrv != 'y') {
    $r_comment = " (disabled)"; 
    echo "<tr><td class='e'>cmmm server (optional)</td>" . "<td class='v'>" . $r_comment . " </td></tr>\n";
  } else {
    $r_comment = check_cmmm();
    echo "<tr><td class='e'>cmmm server (optional)</td>" . "<td class='v'>" . $cmmmsrv_addr . " </td></tr>\n";    
    echo "<tr><td class='e'>cmmm server port</td>" . "<td class='v'>" . $cmmmsrv_port . " </td></tr>\n";    
    echo "<tr><td class='e'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;functionality check forcmmm server</td>";
    if ($r_comment == "(no response)") {  $r_col = "z"; } else { $r_col = "y"; }
    echo "<td class='" . $r_col . "'>$r_comment</td></tr>\n";  
  }
  // JME section
  echo "<tr><td class='e'>JME structure editor (obsolete): URL path</td>";
  if ($enable_jme == "y") {
    $r_comment = "";
    $r_col = "v";
    $dr = "";
    if (strpos($java_codebase,"/") === 0) { $dr = $docroot; }   // add document root if $java_codebase is an absolute path
    if (file_exists($dr . $java_codebase . "/JME.jar")) { 
      $r_col = "y"; 
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(exists and contains JME.jar)";
    } else { 
      $r_col = "z";
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(does not contain JME.jar)";
    }
    echo "<td class='" . $r_col . "'>" . $java_codebase . $r_comment . " </td></tr>\n";
  } else {
    echo "<td class='v'>(disabled)</td></tr>\n";
  }
  // JSME section
  echo "<tr><td class='e'>JSME structure editor: URL path</td>";
  if ($enable_jsme == "y") {
    $r_comment = "";
    $r_col = "v";
    $dr = "";
    if (strpos($jsme_path,"/") === 0) { $dr = $docroot; }   // add document root if $jsme_path is an absolute path
    if (file_exists($dr . $jsme_path . "/jsme.nocache.js")) { 
      $r_col = "y"; 
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(exists and contains jsme.nocache.js)";
    } else { 
      $r_col = "z";
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(does not contain jsme.nocache.js)";
    }
    echo "<td class='" . $r_col . "'>" . $jsme_path . $r_comment . " </td></tr>\n";
  } else {
    echo "<td class='v'>(disabled)</td></tr>\n";
  }
  // GGA Ketcher section
  echo "<tr><td class='e'>Ketcher structure editor: URL path</td>";
  if ($enable_ketcher == "y") {
    $r_comment = "";
    $r_col = "v";
    $dr = "";
    if (strpos($ketcher_path,"/") === 0) { $dr = $docroot; }   // add document root if $ketcher_path is an absolute path
    if (file_exists($dr . $ketcher_path . "/ketcher.js")) { 
      $r_col = "y"; 
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(exists and contains ketcher.js)";
    } else { 
      $r_col = "z";
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(does not contain ketcher.js)";
    }
    echo "<td class='" . $r_col . "'>" . $ketcher_path . $r_comment . " </td></tr>\n";
  } else {
    echo "<td class='v'>(disabled)</td></tr>\n";
  }
  // Flame section
  echo "<tr><td class='e'>Flame structure editor (obsolete): URL path</td>";
  if ($enable_flame == "y") {
    $r_comment = "";
    $r_col = "v";
    $dr = "";
    if (strpos($flame_swf,"/") === 0) { $dr = $docroot; }   // add document root if $flame_swf is an absolute path
    if (file_exists($dr . $flame_swf)) { 
      $r_col = "y"; 
    } else { 
      $r_col = "z";
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(not found)";
    }
    echo "<td class='" . $r_col . "'>" . $flame_swf . $r_comment . " </td></tr>\n";
  } else {
    echo "<td class='v'>(disabled)</td></tr>\n";
  }
  // JSmol/JSV section
  echo "<tr><td class='e'>JSmol/JSV viewer (optional): URL path</td>";
  if ( strlen($jsmoldir) > 0) {
    $r_comment = "";
    $r_col = "v";
    $dr = "";
    if (strpos($jsmoldir,"/") === 0) { $dr = $docroot; }   // add document root if $jsmoldir is an absolute path
    if (file_exists($dr . $jsmoldir . "/JSmol.min.js")) { 
      $r_col = "y"; 
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(exists and contains JSmol.min.js)";
    } else { 
      $r_col = "z";
      $r_comment = " &nbsp;&nbsp;&nbsp;&nbsp;(does not contain JSmol.min.js)";
    }
    echo "<td class='" . $r_col . "'>" . $jsmoldir . $r_comment . " </td></tr>\n";
  } else {
    echo "<td class='v'>(disabled)</td></tr>\n";
  }
  // end

  echo "</table>\n";
}

if ($dbmod_status > 0) {
  echo "<h1>MySQL database</h1>\n";
  echo "<table>\n";
  $r_col = "v";
  $r_col2 = "v";
  $r_comment = "(undefined)";
  $r_comment2 = "(undefined)";
  if ($dbmod_status == 1) {

    $valid_user = "";
    $valid_pw = "";
    $link = mysql_pconnect($hostname,"$rw_user", "$rw_password");
    if ($link === FALSE) {
      $r_comment = mysql_connect_error();
      $r_col = "z";
    } else {
      $valid_user = $rw_user;
      $valid_pw = $rw_password;
      $r_comment = "success";
      $r_col = "y";
      if (mysql_select_db($database) != FALSE) {
        $r_comment2 = "success";
        $r_col2 = "y";
      } else {
        $r_comment2 = "failed";
        $r_col2 = "z";
      }
      mysql_query("SET NAMES $mysql_charset");
      mysql_query("SET SESSION sql_mode = ''");
      mysql_close($link);
    }

  } else {
    //$database = "bla";
    $valid_user = "";
    $valid_pw = "";
    $link = mysqli_connect('p:' . $hostname,"$rw_user", "$rw_password");
    if ($link === FALSE) {
      $r_comment = mysqli_connect_error();
      $r_col = "z";
    } else {
      $valid_user = $rw_user;
      $valid_pw = $rw_password;
      $r_comment = "success";
      $r_col = "y";
      if (mysqli_select_db($link,$database) != FALSE) {
        $r_comment2 = "success";
        $r_col2 = "y";
      } else {
        $r_comment2 = "failed";
        $r_col2 = "z";
      }
      mysqli_query($link,"SET NAMES $mysql_charset");
      mysqli_query($link,"SET SESSION sql_mode = ''");
      //mysqli_free_result($result);
      mysqli_close($link);
    }
  
  }
  echo "<tr><td class='e'>connection to $hostname as rw_user</td>";
  echo "<td class='" . $r_col . "'>$r_comment</td></tr>\n";
  echo "<tr><td class='e'>access to database $database as rw_user</td>";
  echo "<td class='" . $r_col2 . "'>$r_comment2</td></tr>\n";

  $r_col = "v";
  $r_col2 = "v";
  $r_comment = "(undefined)";
  $r_comment2 = "(undefined)";
  if ($dbmod_status == 1) {

    $valid_user = "";
    $valid_pw = "";
    $link = mysql_pconnect($hostname,"$ro_user", "$ro_password");
    if ($link === FALSE) {
      $r_comment = mysql_connect_error();
      $r_col = "z";
    } else {
      $valid_user = $ro_user;
      $valid_pw = $ro_password;
      $r_comment = "success";
      $r_col = "y";
      if (mysql_select_db($database) != FALSE) {
        $r_comment2 = "success";
        $r_col2 = "y";
      } else {
        $r_comment2 = "failed";
        $r_col2 = "z";
      }
      mysql_query("SET NAMES $mysql_charset");
      mysql_query("SET SESSION sql_mode = ''");
      mysql_close($link);
    }

  } else {
    //$database = "bla";
    $valid_user = "";
    $valid_pw = "";
    $link = mysqli_connect('p:' . $hostname,"$ro_user", "$ro_password");
    if ($link === FALSE) {
      $r_comment = mysqli_connect_error();
      $r_col = "z";
    } else {
      $valid_user = $ro_user;
      $valid_pw = $ro_password;
      $r_comment = "success";
      $r_col = "y";
      if (mysqli_select_db($link,$database) != FALSE) {
        $r_comment2 = "success";
        $r_col2 = "y";
      } else {
        $r_comment2 = "failed";
        $r_col2 = "z";
      }
      mysqli_query($link,"SET NAMES $mysql_charset");
      mysqli_query($link,"SET SESSION sql_mode = ''");
      //mysqli_free_result($result);
      mysqli_close($link);
    }
  
  }
  echo "<tr><td class='e'>connection to $hostname as ro_user</td>";
  echo "<td class='" . $r_col . "'>$r_comment</td></tr>\n";
  echo "<tr><td class='e'>access to database $database as ro_user</td>";
  echo "<td class='" . $r_col2 . "'>$r_comment2</td></tr>\n";

  $r_col1 = "v";
  $r_col2 = "v";
  $r_str1 = "";
  $r_str2 = "";
  $db_ver = "(undefined)";
  $i_meta = "(missing)";
  $i_dict = "(missing)";

  if ($valid_user != "") {
    if ($dbmod_status == 1) {

      $link = mysql_pconnect($hostname,"$valid_user", "$valid_pw");
      if ($link === FALSE) {
        $r_str1 = mysql_connect_error();
        $r_col1 = "z";
      } else {
        if (mysql_select_db($database) != FALSE) {
          //$r_comment2 = "success";
          //$r_col2 = "y";
        } else {
          //$r_comment2 = "failed";
          $r_col1 = "z";
        }
        mysql_query("SET NAMES $mysql_charset");
        mysql_query("SET SESSION sql_mode = ''");
        $result = mysql_query("SHOW VARIABLES LIKE 'version'");
        while ($rline = mysql_fetch_assoc($result)) {
          $vname = $rline["Variable_name"];
          $vval  = $rline["Value"];
          //echo "$vname  $vval\n";
          if ($vname == "version") {
            $db_ver = $vval;
          }
        } 
        $result = mysql_query("SHOW TABLES");
        while ($rline = mysql_fetch_array($result, MYSQL_NUM)) {
          $tbl = $rline[0];
          if ($tbl == $metatable) { $i_meta = "installed"; }
          if ($tbl == $fpdeftable) { $i_dict = "installed"; }
        }
       
        $result = mysql_query("SELECT db_id,type,name FROM $metatable");
        $db_list = "";
        while ($rline = mysql_fetch_array($result, MYSQL_ASSOC)) {
          $db_id = $rline['db_id'];
          $type = $rline['type'];
          $name = $rline['name'];
          $db_list .= "$db_id \t $type \t $name \n";
        }
        if ($db_list != "") {
          $db_list = "<big><pre>id \t type \t name \t\t(type 1 = structure, type 2 = reaction)\n" . $db_list . "</pre></big>";
        } else {
          $db_list = "(none)";
        }
        mysql_free_result($result);
        mysql_close($link);
      }

    } else {
      //$database = "bla";
      $link = mysqli_connect('p:' . $hostname,"$valid_user", "$valid_pw");
      if ($link === FALSE) {
        $r_str1 = mysqli_connect_error();
        $r_col1 = "z";
      } else {
        if (mysqli_select_db($link,$database) != FALSE) {
          //$r_comment2 = "success";
          //$r_col2 = "y";
        } else {
          //$r_comment2 = "failed";
          $r_col1 = "z";
        }
        mysqli_query($link,"SET NAMES $mysql_charset");
        mysqli_query($link,"SET SESSION sql_mode = ''");
        $result = mysqli_query($link,"SHOW VARIABLES LIKE 'version'");
        while ($rline = mysqli_fetch_assoc($result)) {
          $vname = $rline["Variable_name"];
          $vval  = $rline["Value"];
          //echo "$vname  $vval\n";
          if ($vname == "version") {
            $db_ver = $vval;
          }
        } 
        $result = mysqli_query($link,"SHOW TABLES");
        while ($rline = mysqli_fetch_array($result, MYSQLI_NUM)) {
          $tbl = $rline[0];
          if ($tbl == $metatable) { $i_meta = "installed"; }
          if ($tbl == $fpdeftable) { $i_dict = "installed"; }
        }
       
        $result = mysqli_query($link,"SELECT db_id,type,name FROM $metatable");
        $db_list = "";
        while ($rline = mysqli_fetch_array($result, MYSQLI_ASSOC)) {
          $db_id = $rline['db_id'];
          $type = $rline['type'];
          $name = $rline['name'];
          $db_list .= "$db_id \t $type \t $name \n";
        }
        if ($db_list != "") {
          $db_list = "<big><pre>id \t type \t name \t\t(type 1 = structure, type 2 = reaction)\n" . $db_list . "</pre></big>";
        } else {
          $db_list = "(none)";
        }
        mysqli_free_result($result);
        mysqli_close($link);
      }
    
    }
    echo "<tr><td class='e'>MySQL server version</td>";
    echo "<td class='" . $r_col1 . "'>$db_ver $r_str1</td></tr>\n";
    echo "<tr><td class='e'>MolDB6 meta table ($metatable)</td>";
    echo "<td class='" . $r_col2 . "'>$i_meta</td></tr>\n";
    echo "<tr><td class='e'>MolDB6 fragment dictionary table ($fpdeftable)</td>";
    echo "<td class='" . $r_col2 . "'>$i_dict</td></tr>\n";
    echo "<tr><td class='e'>MolDB6 data collections</td>";
    echo "<td class='" . $r_col2 . "'>$db_list</td></tr>\n";

  }  // valid_user

  echo "</table>\n";
}  // dbmod_status > 0


echo "<hr>\n<hr style='height:10px'>\n<hr>\n<h1>Outpout of phpinfo()</h1>\n";
phpinfo();


function check_cmmm() {
  global $use_cmmmsrv;
  global $cmmmsrv_addr;
  global $cmmmsrv_port;
  $result = "(no response)";
  if ($use_cmmmsrv == 'y') {
    /* create a TCP/IP socket */
    $socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
    if ($socket < 0) {
      //echo "socket_create() failed.\nreason: " . socket_strerror ($socket) . "\n";
      echo "<!-- could not connect to cmmmsrv - reverting to checkmol/matchmol --!>\n";
      $use_cmmmsrv = "n";
    }
    $sockresult = socket_connect ($socket, $cmmmsrv_addr, $cmmmsrv_port);
    if ($sockresult < 0) {
      //echo "socket_connect() failed.\nreason: ($sockresult) " . socket_strerror($sockresult) . "\n";
      echo "<!-- could not connect to cmmmsrv - reverting to checkmol/matchmol --!>\n";
      $use_cmmmsrv = "n";
    }
  }
  if ($use_cmmmsrv == 'y') {
    $a = socket_read($socket, 250, PHP_NORMAL_READ);
    //echo "$a\n";
    $pos = strpos($a,"READY");
    if ($pos === false) {
      echo "<!-- could not connect to cmmmsrv - reverting to checkmol/matchmol --!>\n";
      $use_cmmmsrv = "n";
    } else 
      $result = $a;
      socket_write($socket,'#### bye');
      socket_close($socket);
    }
    $pos = 0;
  return($result);
}

?>
